---
title: Paper Form Data Extraction
product: Form Library
description: If you have a scanned paper form or a completed PDF, instead of manually copying each answer into a digital form, you can use the AI Form Response Extractor. This plugin uses AI to extract data from filled-out paper forms, form images and PDFs.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Paper Form Data Extraction (Vanilla JS)

SurveyJS provides an MIT-licensed plugin&mdash;[AI Form Response Extractor](https://github.com/surveyjs/ai-form-response-extractor)&mdash;that helps extract structured data from completed paper forms, scanned documents, and digital PDFs using AI. Given a filled-out form (as an image or PDF) and a SurveyJS JSON schema, the tool automatically maps detected values into the corresponding fields. This demo showcases the workflow in action: select and configure an LLM, upload a scanned image or PDF, and provide a JSON schema. The model then returns extracted answers aligned with that schema, which are rendered in a regular SurveyJS form for review and correction before submission.

## Configure an LLM Provider

Data extraction is powered by an LLM of your choice. In this demo, you can switch between OpenAI and Anthropic. API keys are preconfigured for demonstration purposes; however, when integrating into your own application, you must supply your own keys via environment variables.

## Provide a Form JSON Schema

The schema defines the target structure for extracted data. Each question's [`name`](https://surveyjs.io/form-library/documentation/api-reference/question#name) becomes a key in the resulting data object, while the [`title`](https://surveyjs.io/form-library/documentation/api-reference/question#title) provides a human-readable cue to help the model interpret the form.

Additionally, both individual fields and the form itself can include an `aiHint` property, which gives the model extra context about the expected content. This property is used only by the AI and is not visible in the rendered form.

```js
{
  "aiHint": "This form contains basic personal identification fields including full name, date of birth, and contact email.",
  "elements": [
    {
      "type": "text",
      "name": "fullName",
      "title": "Full name",
      "aiHint": "Person's full legal name. May appear as a single line or split into first/middle/last name. Preserve original order and capitalization."
    },
    {
      "type": "text",
      "name": "dateOfBirth",
      "title": "Date of birth",
      "inputType": "date",
      "aiHint": "Person's date of birth. Look for common formats such as DD/MM/YYYY, MM/DD/YYYY, or YYYY-MM-DD. Normalize only if explicitly required by output schema."
    },
    {
      "type": "text",
      "name": "email",
      "title": "Email address",
      "inputType": "email",
      "aiHint": "Contact email address. Must include '@' and domain. Extract exactly as shown without modification or validation correction."
    }
  ]
}
```

## Review the Extracted Data

The extracted output is returned as a plain JavaScript object whose keys correspond to the question `name` values in the schema. To display the results in an editable SurveyJS form, assign this object to the `SurveyModel`'s [`data`](/form-library/documentation/api-reference/survey-data-model#data) property:

```js
import { Model } from "survey-core";

const survey = new Model(surveyJson);
survey.data = extractedData;
```

Because the result is rendered as a standard SurveyJS survey, you automatically get built-in validation, conditional logic, and theming. Users can correct any misread or incomplete fields before final submission.

For more implementation details and source code, see the following GitHub repository:

[AI Form Response Extractor Demo](https://github.com/surveyjs/ai-form-response-extractor-demo (linkStyle))

## See Also

Paper form extraction is part of a broader workflow that unifies data collection across paper and digital channels. For more context, see the following help topic:

[Hybrid Paper and Digital Form Data Collection](/documentation/combine-paper-and-online-survey-form-data (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/angular.md)
- [React](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/jquery.md)


---
title: Paper Form Data Extraction
product: Form Library
description: If you have a scanned paper form or a completed PDF, instead of manually copying each answer into a digital form, you can use the AI Form Response Extractor. This plugin uses AI to extract data from filled-out paper forms, form images and PDFs.
framework: Angular
source: https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Paper Form Data Extraction (Angular)

SurveyJS provides an MIT-licensed plugin&mdash;[AI Form Response Extractor](https://github.com/surveyjs/ai-form-response-extractor)&mdash;that helps extract structured data from completed paper forms, scanned documents, and digital PDFs using AI. Given a filled-out form (as an image or PDF) and a SurveyJS JSON schema, the tool automatically maps detected values into the corresponding fields. This demo showcases the workflow in action: select and configure an LLM, upload a scanned image or PDF, and provide a JSON schema. The model then returns extracted answers aligned with that schema, which are rendered in a regular SurveyJS form for review and correction before submission.

## Configure an LLM Provider

Data extraction is powered by an LLM of your choice. In this demo, you can switch between OpenAI and Anthropic. API keys are preconfigured for demonstration purposes; however, when integrating into your own application, you must supply your own keys via environment variables.

## Provide a Form JSON Schema

The schema defines the target structure for extracted data. Each question's [`name`](https://surveyjs.io/form-library/documentation/api-reference/question#name) becomes a key in the resulting data object, while the [`title`](https://surveyjs.io/form-library/documentation/api-reference/question#title) provides a human-readable cue to help the model interpret the form.

Additionally, both individual fields and the form itself can include an `aiHint` property, which gives the model extra context about the expected content. This property is used only by the AI and is not visible in the rendered form.

```js
{
  "aiHint": "This form contains basic personal identification fields including full name, date of birth, and contact email.",
  "elements": [
    {
      "type": "text",
      "name": "fullName",
      "title": "Full name",
      "aiHint": "Person's full legal name. May appear as a single line or split into first/middle/last name. Preserve original order and capitalization."
    },
    {
      "type": "text",
      "name": "dateOfBirth",
      "title": "Date of birth",
      "inputType": "date",
      "aiHint": "Person's date of birth. Look for common formats such as DD/MM/YYYY, MM/DD/YYYY, or YYYY-MM-DD. Normalize only if explicitly required by output schema."
    },
    {
      "type": "text",
      "name": "email",
      "title": "Email address",
      "inputType": "email",
      "aiHint": "Contact email address. Must include '@' and domain. Extract exactly as shown without modification or validation correction."
    }
  ]
}
```

## Review the Extracted Data

The extracted output is returned as a plain JavaScript object whose keys correspond to the question `name` values in the schema. To display the results in an editable SurveyJS form, assign this object to the `SurveyModel`'s [`data`](/form-library/documentation/api-reference/survey-data-model#data) property:

```js
import { Model } from "survey-core";

const survey = new Model(surveyJson);
survey.data = extractedData;
```

Because the result is rendered as a standard SurveyJS survey, you automatically get built-in validation, conditional logic, and theming. Users can correct any misread or incomplete fields before final submission.

For more implementation details and source code, see the following GitHub repository:

[AI Form Response Extractor Demo](https://github.com/surveyjs/ai-form-response-extractor-demo (linkStyle))

## See Also

Paper form extraction is part of a broader workflow that unifies data collection across paper and digital channels. For more context, see the following help topic:

[Hybrid Paper and Digital Form Data Collection](/documentation/combine-paper-and-online-survey-form-data (linkStyle))

## Files

### `src/app/components/json.ts`

```ts
export const json = {};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/extract-data-from-paper-forms-pdf/vanillajs.md)
